カレンダーコントロールの基本的な操作方法について解説します。
ナビゲーションとスクロール
カレンダーコントロールでは、setShowNavigatorメソッドの設定によって3種類のナビゲータを利用できます。ナビゲータの表示位置は、setNavigatorOrientationメソッドで設定でき、表示されている年や月を自由に切り替えられます。
カレンダーコントロールに用意されているscrollYearとscrollMonthの各メソッドは、指定した年数または月数だけカレンダーをスクロールします。setShowNavigatorメソッドをCalendarNavigators.Noneに設定して、これらのメソッドを活用することで、独自のナビゲーションを実現できます。
これらのナビゲータまたはメソッドを使ってカレンダーをスクロールしたときには、onScrolledイベントが発生します。年に応じて変化する休日などを設定するときに使用します。また、onScrolledイベントの後にはonFocusDateChangedクライアントイベントが発生します。
次のサンプルコードは、スクロール型のナビゲータを設定する方法を示します。
カレンダータイプの切り替え
カレンダーは、日付を選択するMonthDayカレンダー(月-日カレンダー)と月を選択するYearMonthカレンダー(年-月カレンダー)の2つのタイプがあり、カレンダーの対応はsetCalendarTypeメソッドで設定します。既定値はMonthDayカレンダーです。
また、実行時には、ズームイン/スームアウトの2つのボタンによって、カレンダーのタイプを切り替えることができます。ズームボタンを表示するには、setShowZoomButtonメソッドをtrueに設定する必要があります。ズームボタンは、setShowNavigatorメソッドで設定されるナビゲータ上にボタンアイコンが表示されます。
次のサンプルコードは、YearMonthカレンダーを表示する方法を示します。
なお、タッチデバイスの使用時には、カレンダータイプはピンチやストレッチ操作により切り替えることができます。詳細については「カレンダーのタッチ操作」を参照してください。
キーボード操作
カレンダーコントロールでは、以下のキーボード操作が可能です。
キー
説明
[←]
フォーカスが前の日に戻ります。
[→]
フォーカスが次の日に進みます。
[↑]
フォーカスが1週間前に戻ります。
[↓]
フォーカスが1週間先に進みます。
[Home]
フォーカスがその週の最初の日に戻ります。
[End]
フォーカスがその週の最後の日に進みます。
[Ctrl]+[Home]
フォーカスが表示されている月の最初の日に戻ります。
[Ctrl]+[End]
フォーカスが表示されている月の最後の日に進みます。
[PageUp]
フォーカスが1か月前に戻ります。
[PageDown]
フォーカスが1か月先に進みます。
[Ctrl]+[PageUp]
フォーカスが1年前に戻ります。
[Ctrl]+[PageDown]
フォーカスが1年先に進みます。
[Space]または[Enter]
日付を選択します。
月ナビゲータのスキップ月数
scrollRateプロパティを利用して、月ナビゲータのスキップボタンクリック時に移動する月の数を設定することができます。
import '@mescius/inputman/CSS/gc.inputman-js.css';
import { InputMan } from '@mescius/inputman';
InputMan.appearanceStyle = InputMan.AppearanceStyle.Modern;
const gcCalendar = new InputMan.GcCalendar(document.getElementById('gcCalendar'),{
selectedDate: new Date(),
});
document.getElementById('setShowNavigator').addEventListener('change', (e) => {
gcCalendar.setShowNavigator(calendarNavigators[e.target.selectedIndex]);
});
document.getElementById('setNavigatorOrientation').addEventListener('change', (e) => {
gcCalendar.setNavigatorOrientation(navigatorOrientations[e.target.selectedIndex]);
});
document.getElementById('setShowZoomButton').addEventListener('change', (e) => {
gcCalendar.setShowZoomButton(e.target.checked);
});
document.getElementById('skipMonth').addEventListener('change', (e) => {
gcCalendar.scrollRate = Number(e.target.value);
});
const calendarNavigators = [
InputMan.CalendarNavigators.None,
InputMan.CalendarNavigators.Buttons,
InputMan.CalendarNavigators.ScrollBar,
InputMan.CalendarNavigators.Outlook
];
const navigatorOrientations = [
InputMan.NavigatorOrientation.Top,
InputMan.NavigatorOrientation.Bottom,
InputMan.NavigatorOrientation.Left,
InputMan.NavigatorOrientation.Right
];
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>カレンダーコントロール - カレンダーの操作</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function() {
System.import('./src/app');
}
</script>
</head>
<body>
<div id="gcCalendar"></div>
<table class="sample">
<tbody>
<tr>
<th>ナビゲータ</th>
<td>
種類:
<select id="setShowNavigator">
<option>なし</option>
<option>ボタンスタイル</option>
<option>スクロールバースタイル</option>
<option selected>Outlookスタイル</option>
</select><br>
位置:
<select id="setNavigatorOrientation">
<option>上</option>
<option>下</option>
<option>左</option>
<option selected>右</option>
</select><br>
<label><input type="checkbox" checked id="setShowZoomButton">ズームボタンを表示する</label><br>
月ナビケータで移動する月数:<input type="number" id="skipMonth" min ="1" max="11" value="1" >
</td>
</tr>
</tbody>
</table>
</body>
</html>
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
"@mescius/inputman.richtexteditor/CSS": "npm:@mescius/inputman.richtexteditor/CSS",
'@mescius/inputman.richtexteditor/JS/plugins/advlist': 'npm:@mescius/inputman.richtexteditor/JS/plugins/advlist/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/all': 'npm:@mescius/inputman.richtexteditor/JS/plugins/all/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/autosave': 'npm:@mescius/inputman.richtexteditor/JS/plugins/autosave/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/charmap': 'npm:@mescius/inputman.richtexteditor/JS/plugins/charmap/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/directionality': 'npm:@mescius/inputman.richtexteditor/JS/plugins/directionality/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/emoticons': 'npm:@mescius/inputman.richtexteditor/JS/plugins/emoticons/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/fullscreen': 'npm:@mescius/inputman.richtexteditor/JS/plugins/fullscreen/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/htmlcode': 'npm:@mescius/inputman.richtexteditor/JS/plugins/htmlcode/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/image': 'npm:@mescius/inputman.richtexteditor/JS/plugins/image/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/link': 'npm:@mescius/inputman.richtexteditor/JS/plugins/link/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/lists': 'npm:@mescius/inputman.richtexteditor/JS/plugins/lists/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/media': 'npm:@mescius/inputman.richtexteditor/JS/plugins/media/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/pagebreak': 'npm:@mescius/inputman.richtexteditor/JS/plugins/pagebreak/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/preview': 'npm:@mescius/inputman.richtexteditor/JS/plugins/preview/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/save': 'npm:@mescius/inputman.richtexteditor/JS/plugins/save/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/searchreplace': 'npm:@mescius/inputman.richtexteditor/JS/plugins/searchreplace/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/table': 'npm:@mescius/inputman.richtexteditor/JS/plugins/table/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/template': 'npm:@mescius/inputman.richtexteditor/JS/plugins/template/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/wordcount': 'npm:@mescius/inputman.richtexteditor/JS/plugins/wordcount/plugin.js',
'@mescius/inputman.comment': 'npm:@mescius/inputman.comment/index.js',
'@mescius/inputman.comment/CSS': 'npm:@mescius/inputman.comment/CSS',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});

カレンダーコントロールの基本的な操作方法について解説します。
ナビゲーションとスクロール
カレンダーコントロールでは、setShowNavigatorメソッドの設定によって3種類のナビゲータを利用できます。ナビゲータの表示位置は、setNavigatorOrientationメソッドで設定でき、表示されている年や月を自由に切り替えられます。
カレンダーコントロールに用意されているscrollYearとscrollMonthの各メソッドは、指定した年数または月数だけカレンダーをスクロールします。setShowNavigatorメソッドをCalendarNavigators.Noneに設定して、これらのメソッドを活用することで、独自のナビゲーションを実現できます。
これらのナビゲータまたはメソッドを使ってカレンダーをスクロールしたときには、onScrolledイベントが発生します。年に応じて変化する休日などを設定するときに使用します。また、onScrolledイベントの後にはonFocusDateChangedクライアントイベントが発生します。
次のサンプルコードは、スクロール型のナビゲータを設定する方法を示します。
カレンダータイプの切り替え
カレンダーは、日付を選択するMonthDayカレンダー(月-日カレンダー)と月を選択するYearMonthカレンダー(年-月カレンダー)の2つのタイプがあり、カレンダーの対応はsetCalendarTypeメソッドで設定します。既定値はMonthDayカレンダーです。
また、実行時には、ズームイン/スームアウトの2つのボタンによって、カレンダーのタイプを切り替えることができます。ズームボタンを表示するには、setShowZoomButtonメソッドをtrueに設定する必要があります。ズームボタンは、setShowNavigatorメソッドで設定されるナビゲータ上にボタンアイコンが表示されます。
次のサンプルコードは、YearMonthカレンダーを表示する方法を示します。
なお、タッチデバイスの使用時には、カレンダータイプはピンチやストレッチ操作により切り替えることができます。詳細については「カレンダーのタッチ操作」を参照してください。
キーボード操作
カレンダーコントロールでは、以下のキーボード操作が可能です。
キー
説明
[←]
フォーカスが前の日に戻ります。
[→]
フォーカスが次の日に進みます。
[↑]
フォーカスが1週間前に戻ります。
[↓]
フォーカスが1週間先に進みます。
[Home]
フォーカスがその週の最初の日に戻ります。
[End]
フォーカスがその週の最後の日に進みます。
[Ctrl]+[Home]
フォーカスが表示されている月の最初の日に戻ります。
[Ctrl]+[End]
フォーカスが表示されている月の最後の日に進みます。
[PageUp]
フォーカスが1か月前に戻ります。
[PageDown]
フォーカスが1か月先に進みます。
[Ctrl]+[PageUp]
フォーカスが1年前に戻ります。
[Ctrl]+[PageDown]
フォーカスが1年先に進みます。
[Space]または[Enter]
日付を選択します。
月ナビゲータのスキップ月数
scrollRateプロパティを利用して、月ナビゲータのスキップボタンクリック時に移動する月の数を設定することができます。
import * as React from "react";
import { createRoot } from 'react-dom/client';
import { GcCalendar } from "@mescius/inputman.react";
import { InputMan } from "@mescius/inputman";
import '@mescius/inputman/CSS/gc.inputman-js.css';
const calendarNavigators = [
InputMan.CalendarNavigators.None,
InputMan.CalendarNavigators.Buttons,
InputMan.CalendarNavigators.ScrollBar,
InputMan.CalendarNavigators.Outlook
];
const navigatorOrientations = [
InputMan.NavigatorOrientation.Top,
InputMan.NavigatorOrientation.Bottom,
InputMan.NavigatorOrientation.Left,
InputMan.NavigatorOrientation.Right
];
class App extends React.Component {
constructor(props, context) {
InputMan.appearanceStyle = InputMan.AppearanceStyle.Modern;
super(props, context);
this.state = {
showZoomButton: true,
showNavigator: InputMan.CalendarNavigators.Outlook,
navigatorOrientation: InputMan.NavigatorOrientation.Right,
scrollRate: 1,
selectedDate:new Date()
};
}
render() {
return (
<div>
<GcCalendar
scrollRate={this.state.scrollRate}
showZoomButton={this.state.showZoomButton}
showNavigator={this.state.showNavigator}
selectedDate={this.state.selectedDate}
navigatorOrientation={this.state.navigatorOrientation} />
<table class="sample">
<tr>
<th>ナビゲータ</th>
<td>
種類:
<select id="setShowNavigator" onChange={(e) => this.setState({ showNavigator: calendarNavigators[e.target.selectedIndex] })}>
<option>なし</option>
<option>ボタンスタイル</option>
<option>スクロールバースタイル</option>
<option selected>Outlookスタイル</option>
</select><br />
位置:
<select id="setNavigatorOrientation" onChange={(e) => this.setState({ navigatorOrientation: navigatorOrientations[e.target.selectedIndex] })}>
<option>上</option>
<option>下</option>
<option>左</option>
<option selected>右</option>
</select><br />
<input type="checkbox" checked={this.state.showZoomButton} onChange={(e) => this.setState({ showZoomButton: e.target.checked })}
id="setShowZoomButton"></input><label>ズームボタンを表示する</label><br />
月ナビケータで移動する月数:<input type="number" min="1" max="11" value={this.state.scrollRate} onChange={(e) => this.setState({ scrollRate: Number(e.target.value) })}></input>
</td>
</tr>
</table>
</div>)
}
}
const root = createRoot(document.getElementById('app'));
root.render(<App />);
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<title>カレンダーコントロール - カレンダーの操作</title>
<!-- SystemJS -->
<script src="node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
window.onload = function() {
System.import('./src/app');
}
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
},
// map tells the System loader where to look for things
map: {
'@mescius/inputman': 'npm:@mescius/inputman/index.js',
'@mescius/inputman.react': 'npm:@mescius/inputman.react/GcInputMan.component.js',
'@mescius/inputman/CSS': 'npm:@mescius/inputman/CSS',
'@mescius/inputman.comment': 'npm:@mescius/inputman.comment/index.js',
'@mescius/inputman.comment.react': 'npm:@mescius/inputman.comment.react/GcInputMan.component.js',
'@mescius/inputman.comment/CSS': 'npm:@mescius/inputman.comment/CSS',
'@mescius/inputman.richtexteditor': 'npm:@mescius/inputman.richtexteditor/index.js',
'@mescius/inputman.richtexteditor.react': 'npm:@mescius/inputman.richtexteditor.react/GcInputMan.component.js',
'@mescius/inputman.richtexteditor/CSS': 'npm:@mescius/inputman.richtexteditor/CSS',
'@mescius/inputman.richtexteditor/JS/plugins/advlist': 'npm:@mescius/inputman.richtexteditor/JS/plugins/advlist/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/all': 'npm:@mescius/inputman.richtexteditor/JS/plugins/all/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/autosave': 'npm:@mescius/inputman.richtexteditor/JS/plugins/autosave/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/charmap': 'npm:@mescius/inputman.richtexteditor/JS/plugins/charmap/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/directionality': 'npm:@mescius/inputman.richtexteditor/JS/plugins/directionality/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/emoticons': 'npm:@mescius/inputman.richtexteditor/JS/plugins/emoticons/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/fullscreen': 'npm:@mescius/inputman.richtexteditor/JS/plugins/fullscreen/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/htmlcode': 'npm:@mescius/inputman.richtexteditor/JS/plugins/htmlcode/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/image': 'npm:@mescius/inputman.richtexteditor/JS/plugins/image/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/link': 'npm:@mescius/inputman.richtexteditor/JS/plugins/link/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/lists': 'npm:@mescius/inputman.richtexteditor/JS/plugins/lists/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/media': 'npm:@mescius/inputman.richtexteditor/JS/plugins/media/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/pagebreak': 'npm:@mescius/inputman.richtexteditor/JS/plugins/pagebreak/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/preview': 'npm:@mescius/inputman.richtexteditor/JS/plugins/preview/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/save': 'npm:@mescius/inputman.richtexteditor/JS/plugins/save/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/searchreplace': 'npm:@mescius/inputman.richtexteditor/JS/plugins/searchreplace/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/table': 'npm:@mescius/inputman.richtexteditor/JS/plugins/table/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/template': 'npm:@mescius/inputman.richtexteditor/JS/plugins/template/plugin.js',
'@mescius/inputman.richtexteditor/JS/plugins/wordcount': 'npm:@mescius/inputman.richtexteditor/JS/plugins/wordcount/plugin.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.react.grid': 'npm:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.base': 'npm:@mescius/wijmo.react.base/index.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets/styles': 'npm:@mescius/spread-sheets/styles',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
'node_modules': {
defaultExtension: 'js',
},
},
});
})(this);